diff -ruNp ejudge-2.3.18/userlist_clnt/get_count.c ejudge/userlist_clnt/get_count.c
--- ejudge-2.3.18/userlist_clnt/get_count.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/userlist_clnt/get_count.c	2011-07-11 09:02:03.783287370 +0400
@@ -0,0 +1,87 @@
+/* -*- mode: c -*- */
+/* $Id: get_count.c 6262 2011-04-22 05:15:27Z cher $ */
+
+/* Copyright (C) 2011 Alexander Chernov <cher@ejudge.ru> */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "userlist_clnt/private.h"
+
+enum { MAX_FILTER_LEN = 8192 };
+
+int
+userlist_clnt_get_count(
+        struct userlist_clnt *clnt,
+        int cmd,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        long long *p_count)
+{
+  struct userlist_pk_list_users_2 *out = 0;
+  struct userlist_pk_count *in = 0;
+  struct userlist_packet *in_generic = 0;
+  void *in_void = 0;
+  int filter_len = 0, r;
+  size_t out_size, in_size = 0;
+  long long count = 0;
+
+  if (!filter) filter = "";
+  filter_len = strlen(filter);
+  if (filter_len < 0 || filter_len > MAX_FILTER_LEN)
+    return -ULS_ERR_PROTOCOL;
+
+  out_size = sizeof(*out) + filter_len;
+  out = alloca(out_size);
+  memset(out, 0, out_size);
+  out->request_id = cmd;
+  out->contest_id = contest_id;
+  out->group_id = group_id;
+  out->filter_len = filter_len;
+  memcpy(out->data, filter, filter_len + 1);
+
+  if ((r = userlist_clnt_send_packet(clnt, out_size, out)) < 0) return r;
+  if ((r = userlist_clnt_read_and_notify(clnt, &in_size, &in_void)) < 0)
+    return r;
+
+  if (in_size < sizeof(*in_generic)) {
+    xfree(in_void); in_void = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  in_generic = (struct userlist_packet *) in_void; in_void = 0;
+  if (in_generic->id < 0) {
+    r = in_generic->id;
+    xfree(in_generic); in_generic = 0;
+    return r;
+  }
+  if (in_generic->id != ULS_COUNT) {
+    r = in_generic->id;
+    xfree(in_generic); in_generic = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  if (in_size != sizeof(*in)) {
+    xfree(in_generic); in_generic = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  in = (struct userlist_pk_count*) in_generic; in_generic = 0;
+  count = in->count;
+  if (count < 0) {
+    xfree(in); in = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  xfree(in); in = 0;
+  if (p_count) *p_count = count;
+
+  return ULS_COUNT;
+}
+
diff -ruNp ejudge-2.3.18/userlist_clnt/get_prev_user_id.c ejudge/userlist_clnt/get_prev_user_id.c
--- ejudge-2.3.18/userlist_clnt/get_prev_user_id.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/userlist_clnt/get_prev_user_id.c	2011-07-11 09:02:03.740288159 +0400
@@ -0,0 +1,88 @@
+/* -*- mode: c -*- */
+/* $Id: get_prev_user_id.c 6321 2011-05-08 18:56:21Z cher $ */
+
+/* Copyright (C) 2011 Alexander Chernov <cher@ejudge.ru> */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "userlist_clnt/private.h"
+
+enum { MAX_FILTER_LEN = 8192 };
+
+int
+userlist_clnt_get_prev_user_id(
+        struct userlist_clnt *clnt,
+        int cmd,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id)
+{
+  struct userlist_pk_list_users_2 *out = 0;
+  struct userlist_pk_login_ok *in = 0;
+  struct userlist_packet *in_generic = 0;
+  void *in_void = 0;
+  int filter_len = 0, r;
+  size_t out_size, in_size = 0;
+
+  if (!filter) filter = "";
+  filter_len = strlen(filter);
+  if (filter_len < 0 || filter_len > MAX_FILTER_LEN)
+    return -ULS_ERR_PROTOCOL;
+
+  out_size = sizeof(*out) + filter_len;
+  out = alloca(out_size);
+  memset(out, 0, out_size);
+  out->request_id = cmd;
+  out->contest_id = contest_id;
+  out->group_id = group_id;
+  out->user_id = user_id;
+  out->filter_len = filter_len;
+  memcpy(out->data, filter, filter_len + 1);
+
+  if ((r = userlist_clnt_send_packet(clnt, out_size, out)) < 0) return r;
+  if ((r = userlist_clnt_read_and_notify(clnt, &in_size, &in_void)) < 0)
+    return r;
+
+  if (in_size < sizeof(*in_generic)) {
+    xfree(in_void); in_void = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  in_generic = (struct userlist_packet *) in_void; in_void = 0;
+  if (in_generic->id < 0) {
+    r = in_generic->id;
+    xfree(in_generic); in_generic = 0;
+    return r;
+  }
+  if (in_generic->id != ULS_LOGIN_OK) {
+    r = in_generic->id;
+    xfree(in_generic); in_generic = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  if (in_size != sizeof(*in)) {
+    xfree(in_generic); in_generic = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  in = (struct userlist_pk_login_ok*) in_generic; in_generic = 0;
+  user_id = in->user_id;
+  if (user_id < 0) {
+    xfree(in); in = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  xfree(in); in = 0;
+  if (p_user_id) *p_user_id = user_id;
+
+  return ULS_LOGIN_OK;
+}
+
diff -ruNp ejudge-2.3.18/userlist_clnt/list_users_2.c ejudge/userlist_clnt/list_users_2.c
--- ejudge-2.3.18/userlist_clnt/list_users_2.c	1970-01-01 03:00:00.000000000 +0300
+++ ejudge/userlist_clnt/list_users_2.c	2011-07-11 09:02:03.766287682 +0400
@@ -0,0 +1,94 @@
+/* -*- mode: c -*- */
+/* $Id: list_users_2.c 6262 2011-04-22 05:15:27Z cher $ */
+
+/* Copyright (C) 2011 Alexander Chernov <cher@ejudge.ru> */
+
+/*
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation; either version 2 of the License, or
+ * (at your option) any later version.
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ */
+
+#include "userlist_clnt/private.h"
+
+enum { MAX_FILTER_LEN = 8192 };
+enum { MAX_XML_LEN = 134217728 };
+
+int
+userlist_clnt_list_users_2(
+        struct userlist_clnt *clnt,
+        int cmd,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        int offset,
+        int count,
+        unsigned char **p_info)
+{
+  struct userlist_pk_list_users_2 *out = 0;
+  struct userlist_pk_xml_data *in = 0;
+  struct userlist_packet *in_generic = 0;
+  void *in_void = 0;
+  int filter_len = 0, r;
+  size_t out_size, in_size = 0;
+
+  if (!filter) filter = "";
+  filter_len = strlen(filter);
+  if (filter_len < 0 || filter_len > MAX_FILTER_LEN)
+    return -ULS_ERR_PROTOCOL;
+
+  out_size = sizeof(*out) + filter_len;
+  out = alloca(out_size);
+  memset(out, 0, out_size);
+  out->request_id = cmd;
+  out->contest_id = contest_id;
+  out->group_id = group_id;
+  out->filter_len = filter_len;
+  out->offset = offset;
+  out->count = count;
+  memcpy(out->data, filter, filter_len + 1);
+
+  if ((r = userlist_clnt_send_packet(clnt, out_size, out)) < 0) return r;
+  if ((r = userlist_clnt_read_and_notify(clnt, &in_size, &in_void)) < 0)
+    return r;
+
+  if (in_size < sizeof(*in_generic)) {
+    xfree(in_void); in_void = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  in_generic = (struct userlist_packet *) in_void; in_void = 0;
+  if (in_generic->id < 0) {
+    r = in_generic->id;
+    xfree(in_generic); in_generic = 0;
+    return r;
+  }
+  if (in_generic->id != ULS_XML_DATA) {
+    r = in_generic->id;
+    xfree(in_generic); in_generic = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  if (in_size < sizeof(*in)) {
+    xfree(in_generic); in_generic = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  in = (struct userlist_pk_xml_data*) in_generic; in_generic = 0;
+  if (in->info_len > MAX_XML_LEN) {
+    xfree(in); in = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  if (in->info_len != strlen(in->data)) {
+    xfree(in); in = 0;
+    return -ULS_ERR_PROTOCOL;
+  }
+  *p_info = xstrdup(in->data);
+  xfree(in); in = 0;
+
+  return ULS_XML_DATA;
+}
+
diff -ruNp ejudge-2.3.18/userlist_clnt.h ejudge/userlist_clnt.h
--- ejudge-2.3.18/userlist_clnt.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/userlist_clnt.h	2011-07-11 09:02:04.293277996 +0400
@@ -1,10 +1,10 @@
 /* -*- c -*- */
-/* $Id: userlist_clnt.h 5948 2010-07-15 09:47:25Z cher $ */
+/* $Id: userlist_clnt.h 6316 2011-05-08 07:09:12Z cher $ */
 
 #ifndef __USERLIST_CLNT_H__
 #define __USERLIST_CLNT_H__
 
-/* Copyright (C) 2002-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2002-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -395,4 +395,46 @@ userlist_clnt_get_xml_by_text(
         const unsigned char *request_text,
         unsigned char **reply_text);
 
+int
+userlist_clnt_list_users_2(
+        struct userlist_clnt *clnt,
+        int cmd,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        int offset,
+        int count,
+        unsigned char **p_info);
+
+int
+userlist_clnt_get_count(
+        struct userlist_clnt *clnt,
+        int cmd,
+        int contest_id,
+        int group_id,
+        const unsigned char *filter,
+        long long *p_count);
+
+struct userlist_pk_create_user_2;
+int
+userlist_clnt_create_user_2(
+        struct userlist_clnt *clnt,
+        int cmd,
+        const struct userlist_pk_create_user_2 *params,
+        const unsigned char *login_str,
+        const unsigned char *email_str,
+        const unsigned char *reg_password_str,
+        const unsigned char *cnts_password_str,
+        const unsigned char *cnts_name_str,
+        int *p_user_id);
+int
+userlist_clnt_get_prev_user_id(
+        struct userlist_clnt *clnt,
+        int cmd,
+        int contest_id,
+        int group_id,
+        int user_id,
+        const unsigned char *filter,
+        int *p_user_id);
+
 #endif /* __USERLIST_CLNT_H__ */
diff -ruNp ejudge-2.3.18/userlist_proto.h ejudge/userlist_proto.h
--- ejudge-2.3.18/userlist_proto.h	2011-04-10 09:25:24.000000000 +0400
+++ ejudge/userlist_proto.h	2011-07-11 09:02:04.176280147 +0400
@@ -1,10 +1,10 @@
 /* -*- c -*- */
-/* $Id: userlist_proto.h 5948 2010-07-15 09:47:25Z cher $ */
+/* $Id: userlist_proto.h 6377 2011-06-19 19:49:48Z cher $ */
 
 #ifndef __USERLIST_PROTO_H__
 #define __USERLIST_PROTO_H__
 
-/* Copyright (C) 2002-2010 Alexander Chernov <cher@ejudge.ru> */
+/* Copyright (C) 2002-2011 Alexander Chernov <cher@ejudge.ru> */
 
 /*
  * This program is free software; you can redistribute it and/or modify
@@ -108,6 +108,20 @@ enum
     ULS_CREATE_GROUP_MEMBER,
     ULS_DELETE_GROUP_MEMBER,
     ULS_GET_GROUPS,
+    ULS_LIST_ALL_USERS_2,
+    ULS_GET_USER_COUNT,
+    ULS_LIST_ALL_GROUPS_2,
+    ULS_GET_GROUP_COUNT,
+    ULS_PRIV_SET_REG_PASSWD_PLAIN,
+    ULS_PRIV_SET_REG_PASSWD_SHA1,
+    ULS_PRIV_SET_CNTS_PASSWD_PLAIN,
+    ULS_PRIV_SET_CNTS_PASSWD_SHA1,
+    ULS_CREATE_USER_2,
+    ULS_PREV_USER,
+    ULS_NEXT_USER,
+    ULS_LIST_ALL_USERS_3,
+    ULS_LIST_ALL_USERS_4,
+    ULS_GET_GROUP_INFO,
 
     ULS_LAST_CMD
   };
@@ -128,6 +142,7 @@ enum
     ULS_TEXT_DATA,
     ULS_NEW_PASSWORD,
     ULS_TEXT_DATA_FAILURE,
+    ULS_COUNT,
   };
 
 /* various error codes */
@@ -373,6 +388,54 @@ struct userlist_pk_dump_database
   int   html_flag;
 };
 
+struct userlist_pk_list_users_2
+{
+  short request_id;
+  int   contest_id;
+  int   group_id;
+  int   user_id;
+  int   filter_len;
+  int   offset;
+  int   count;
+  unsigned char data[1];
+};
+
+struct userlist_pk_create_user_2
+{
+  short request_id;
+  int login_len;
+  int email_len;
+  int send_email_flag;
+  int confirm_email_flag;
+  int random_password_flag;
+  int reg_password_len;
+  int use_sha1_flag;
+  int is_privileged_flag;
+  int is_invisible_flag;
+  int is_banned_flag;
+  int is_locked_flag;
+  int show_login_flag;
+  int show_email_flag;
+  int read_only_flag;
+  int never_clean_flag;
+  int simple_registration_flag;
+  int contest_id;
+  int cnts_status;
+  int cnts_is_invisible_flag;
+  int cnts_is_banned_flag;
+  int cnts_is_locked_flag;
+  int cnts_is_incomplete_flag;
+  int cnts_is_disqualified_flag;
+  int cnts_use_reg_passwd_flag;
+  int cnts_set_null_passwd_flag;
+  int cnts_random_password_flag;
+  int cnts_password_len;
+  int cnts_use_sha1_flag;
+  int cnts_name_len;
+  int group_id;
+  unsigned char data[5];
+};
+
 /* server->client replies */
 struct userlist_pk_login_ok
 {
@@ -445,4 +508,10 @@ struct userlist_pk_new_password
   char        data[3];
 };
 
+struct userlist_pk_count
+{
+  short reply_id;
+  long long count;
+};
+
 #endif /* __USERLIST_PROTO_H__ */
